<?php

namespace Core;

use DateTime;

class Config
{
    const EKR_RUB_PRICE = 30;
    const KR_TO_EKR_EXCHANGE = 500;
    const EKR_TO_KR_EXCHANGE = 200;
    private const HOSTNAME = 'new-combats.tech';
    public const GAMENAME = 'Новый Бойцовский Клуб';
    private static self $instance;

    private function __construct()
    {
        //singleton
    }

    /** Самый распространённый субдомен
     *  //img.{siteName}.
     * @return string
     */
    public static function img(): string
    {
        return self::subdomain('img');
    }

    private static function subdomain(string $name): string
    {
        return DIRECTORY_SEPARATOR . DIRECTORY_SEPARATOR . $name . '.' . self::HOSTNAME;
    }

    public static function get(?string $key = null)
    {
        $c['ver'] = '0.8.2 alpha';
        /* Конфигурации игры */
        $c['title'] = self::GAMENAME . ' - Бесплатная, браузерная онлайн игра'; //Название игры
        $c['keys'] = self::GAMENAME . ', combats.com, ' . self::GAMENAME . ' игра, ' . self::GAMENAME . ' играть, игра ' . self::GAMENAME . ', старый ' . self::GAMENAME . ', ' . self::GAMENAME . ' онлайн игра, ' . self::GAMENAME . ' браузерная игра, играть в ' . self::GAMENAME . ', игра бк, бк игра, старый бк, играть в бк, бк онлайн игра, новый бк, Легендарный ' . self::GAMENAME . ', легендарный бк, combats, комбатс, combats ru, combats com, OldBK, oldbk ru, oldbk com, олдбк, old bk, олд бк, mycombats, rebk, recombats, oldcombats, obk2'; //Ключевые слова META
        $c['desc'] = self::GAMENAME . ' – это бесплатная увлекательная браузерная онлайн игра 2004-2009г, в которой сконцентрировано все самое лучшее от современных онлайн игр. В этой браузерной игре заложены самые интересные традиции всем известной онлайн игры под названием «' . self::GAMENAME . ' 2004-2009», которая, кстати, стала первооткрывателем всех браузерных игр.'; //Описание META
        $c['footer'] = self::GAMENAME . ' © 2013-' . date('Y');

        //Сервера
        $c['host'] = self::HOSTNAME;
        $c['forum'] = self::subdomain('forum');
        $c['img'] = 'img.' . self::HOSTNAME;
        $c['https'] = DIRECTORY_SEPARATOR . DIRECTORY_SEPARATOR . self::HOSTNAME;
        $c['img2'] = self::subdomain('img');
        $c['exit'] = "<script>window.location.replace('{$c['https']}');</script>";
        $c['support'] = 'support@' . self::HOSTNAME;

        //Бот клон
        $c['bot_level'] = 0; // до какого лвл бот (включительно)
        $c['propsk_die'] = 0; //Смерть при пропуске ходов, 0 - выкл. , >= 1 - количество пропусков до смерти при нападении

        $c['exp'] = 0; //бонус опыта

        //Скупка
        $c['shop_type2'] = 90; //в березку НЕ ТРОГАТЬ
        $c['shop_all'] = 0; //Скупка на все! , 0 - сделать для отключения скупки.
        $c['shop_all_type1'] = 100; //Скупка только с госе! , 0 - сделать для отключения скупки.
        $c['shop_all_type2'] = 100; //Скупка только с березки! , 0 - сделать для отключения скупки.
        //

        $c['limitedexp'] = false; //лимит опыта
        $c['expstop'] = 2999999; //9; //Опыт на котором останавливаемся 11 149999999
        $c['expstopu'] = 2999999; //Опыт на котором останавливаемся
        $c['noobgade'] = false; //нуб квест (пещера)
        $c['level_transfer'] = 8; //С какого уровня разрешены передачи
        $c['noitembuy'] = false; //Не требует ресурсы для покупки
        $c['effz'] = 0; //Скольким секундам равен заряд
        $c['money_haot'] = true; //кр за хаоты
        $c['bonuslevel'] = true; //Бонус уровня
        $c['bonussocial'] = false; //Бонус социальный

        $c['db_host'] = 'db';
        $c['db_user'] = 'prod1';
        $c['db_name'] = 'game_production';
        $c['db_password'] = 'Bz@fGaZjFU2206Ua';
        return $c[$key] ?? $c;
    }

    public static function init(): Config
    {
        if (!isset(self::$instance)) {
            self::$instance = new static();
        }
        return self::$instance;
    }

    public static function getCopyright(): string
    {
        return '©' . (new DateTime())->format('Y') . ' Copyright «<a href="//' . self::HOSTNAME . '">' . self::GAMENAME . '</a>». All Rights Reserved.';
    }
}
